StreamByteBuffer (Grails 3.3.8)
Date: 2018-08-10

Package: org.grails.buffer

## [Java] Class StreamByteBuffer

- org.grails.buffer.StreamByteBuffer

- An in-memory buffer that provides OutputStream and InputStream interfaces. This is more efficient than using ByteArrayOutputStream/ByteArrayInputStream This is not thread-safe, it is intended to be used by a single Thread.

  Authors:
    Lari Hotari, Sagire Software Oy

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `enum` | `StreamByteBuffer.ReadMode` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `StreamByteBuffer ()` An in-memory buffer that provides OutputStream and InputStream interfaces.
    `StreamByteBuffer (int chunkSize)`
    `StreamByteBuffer (int chunkSize, StreamByteBuffer.ReadMode readMode)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected int` | `allocateSpace()`
    `` | `void` | `clear()`
    `` | `java.io.InputStream` | `getInputStream()`
    `` | `java.io.OutputStream` | `getOutputStream()`
    `` | `StreamByteBuffer.ReadMode` | `getReadMode()`
    `` | `protected int` | `prepareRead()`
    `` | `byte[]` | `readAsByteArray()`
    `` | `java.lang.String` | `readAsString(java.lang.String encoding)`
    `` | `java.lang.String` | `readAsString(java.nio.charset.Charset charset)`
    `` | `void` | `reset()`
    `` | `void` | `retainAfterReadingMode()`
    `` | `void` | `setReadMode(StreamByteBuffer.ReadMode readMode)`
    `` | `int` | `totalBytesUnread()`
    `` | `void` | `writeTo(java.io.OutputStream target)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### public StreamByteBuffer()

      An in-memory buffer that provides OutputStream and InputStream interfaces. This is more efficient than using ByteArrayOutputStream/ByteArrayInputStream This is not thread-safe, it is intended to be used by a single Thread.

      Authors:
        Lari Hotari, Sagire Software Oy

    - #### public StreamByteBuffer(int chunkSize)

    - #### public StreamByteBuffer(int chunkSize, StreamByteBuffer.ReadMode readMode)

  - ### Method Detail

    - #### protected int allocateSpace()

    - #### public void clear()

    - #### public java.io.InputStream getInputStream()

    - #### public java.io.OutputStream getOutputStream()

    - #### public StreamByteBuffer.ReadMode getReadMode()

    - #### protected int prepareRead()

    - #### public byte[] readAsByteArray()

    - #### public java.lang.String readAsString(java.lang.String encoding)

    - #### public java.lang.String readAsString(java.nio.charset.Charset charset)

    - #### public void reset()

    - #### public void retainAfterReadingMode()

    - #### public void setReadMode(StreamByteBuffer.ReadMode readMode)

    - #### public int totalBytesUnread()

    - #### public void writeTo(java.io.OutputStream target)